/***************************************************
//Web: http://www.buydisplay.com
EastRising Technology Co.,LTD
Examples for ER-TFTM018-3
Display is Hardward SPI 4-Wire SPI Interface 
Tested and worked with: 
Works with Raspberry pi
****************************************************/

#include <bcm2835.h>
#include <stdio.h>
#include <time.h>
#include "st7735.h"

char value[10] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};
int main(int argc, char **argv)
{
    time_t now;
    struct tm *timenow;
 
    FILE *pFile ;
    /* 1 pixel of 888 bitmap = 3 bytes */
    size_t pixelSize = 3;
    unsigned char bmpBuffer[TFT_WIDTH * TFT_HEIGHT * 3];

    if(!bcm2835_init())
    {
        return -1;
    }


  
    st7735_begin();
    st7735_mono_bitmap(0, 16, mono_bmp, 128, 128, GREEN);
    st7735_display();
    bcm2835_delay(2000);

    pFile = fopen("pic1.bmp", "r");

   if (pFile == NULL) {
        printf("file not exist\n");
        return 0;
    }
  
    fseek(pFile, 54, 0);
    fread(bmpBuffer, pixelSize, TFT_WIDTH * TFT_HEIGHT, pFile);
    fclose(pFile);

    st7735_bitmap24(0, 0, bmpBuffer, 128, 160);
    st7735_display();
    bcm2835_delay(2000);


    pFile = fopen("pic2.bmp", "r");

   if (pFile == NULL) {
        printf("file not exist\n");
        return 0;
    }
  
    fseek(pFile, 54, 0);
    fread(bmpBuffer, pixelSize, TFT_WIDTH * TFT_HEIGHT, pFile);
    fclose(pFile);

    st7735_bitmap24(0, 0, bmpBuffer, 128, 160);
    st7735_display();
    bcm2835_delay(2000);


    pFile = fopen("pic3.bmp", "r");

   if (pFile == NULL) {
        printf("file not exist\n");
        return 0;
    }
  
    fseek(pFile, 54, 0);
    fread(bmpBuffer, pixelSize, TFT_WIDTH * TFT_HEIGHT, pFile);
    fclose(pFile);

    st7735_bitmap24(0, 0, bmpBuffer, 128, 160);
    st7735_display();
    bcm2835_delay(2000);


    pFile = fopen("pic4.bmp", "r");

   if (pFile == NULL) {
        printf("file not exist\n");
        return 0;
    }
  
    fseek(pFile, 54, 0);
    fread(bmpBuffer, pixelSize, TFT_WIDTH * TFT_HEIGHT, pFile);
    fclose(pFile);

    st7735_bitmap24(0, 0, bmpBuffer, 128, 160);
    st7735_display();
    bcm2835_delay(2000);

    pFile = fopen("pic5.bmp", "r");

   if (pFile == NULL) {
        printf("file not exist\n");
        return 0;
    }
  
    fseek(pFile, 54, 0);
    fread(bmpBuffer, pixelSize, TFT_WIDTH * TFT_HEIGHT, pFile);
    fclose(pFile);

    st7735_bitmap24(0, 0, bmpBuffer, 128, 160);
    st7735_display();
    bcm2835_delay(2000);

    pFile = fopen("pic6.bmp", "r");

   if (pFile == NULL) {
        printf("file not exist\n");
        return 0;
    }
  
    fseek(pFile, 54, 0);
    fread(bmpBuffer, pixelSize, TFT_WIDTH * TFT_HEIGHT, pFile);
    fclose(pFile);

    st7735_bitmap24(0, 0, bmpBuffer, 128, 160);
    st7735_display();
    bcm2835_delay(2000);


    st7735_clear();
    printf("TFT example. Press Ctrl + C to exit.\n");

    uint16_t i=100;
    while(1)
    {
        time(&now);
        timenow = localtime(&now);


   	st7735_string(25,10, "EastRising", 16, 1, CYAN);  
   	     
       st7735_string(20, 50, "hour", 16, 0, RED); 
       st7735_char3216(60, 50, ':' , WHITE);

        st7735_char3216(85, 50, value[timenow->tm_hour / 10],RED);
        st7735_char3216(110, 50, value[timenow->tm_hour % 10],RED);
  
        st7735_char3216(5, 85, value[timenow->tm_min / 10], GREEN);
        st7735_char3216(30, 85, value[timenow->tm_min % 10], GREEN);
        st7735_char3216(60, 85, ':' , WHITE);
        st7735_char3216(85, 85, value[timenow->tm_sec / 10],  BLUE);
        st7735_char3216(110, 85, value[timenow->tm_sec % 10],  BLUE);

        st7735_string(10, 140, "buydisplay.com", 16, 1, i); 
	i+=1000; if(i>=65536)i=1000;
    

        st7735_display();
      
    }
    bcm2835_spi_end();
    bcm2835_close();
    return 0;
}

